# Script to convert C headers to ASM

text = '''
;int bbVersion();
;void bbSetBlitz3DDebugMode( int debugmode );
;void bbSetBlitz3DDebugCallback( void (*callback)(const char *) );
;void bbSetBlitz3DEventCallback( int (*callback)(int hwnd,int msg,int wparam,int lparam) );
;void bbSetBlitz3DHWND( int hwndparent );
;void bbSetBlitz3DTitle( const char *title,const char *close );
;int bbBeginBlitz3D();
;int bbBeginBlitz3DEx( int hwnd,int flags );
;void bbEndBlitz3D();
;int bbValidateGraphics();
;void bbRuntimeError( const char * );
;const char *bbSystemProperty(const char *name);
;int bbMilliSecs();
;void bbDelay( int ms );
;void bbShowPointer();
;void bbHidePointer();
;BBTimer bbCreateTimer( int hz );
;void bbFreeTimer(BBTimer timer);
;void bbWaitTimer(BBTimer timer);
;int bbKeyDown( int n );
;int bbKeyHit( int n );
;int bbGetKey();
;int bbWaitKey();
;void bbFlushKeys();
;int bbMouseDown( int n );
;int bbMouseHit( int n );
;int bbGetMouse();
;int bbWaitMouse();
;int bbMouseX();
;int bbMouseY();
;int bbMouseZ();
;int bbMouseXSpeed();
;int bbMouseYSpeed();
;int bbMouseZSpeed();
;void bbMoveMouse( int x,int y );
;void bbFlushMouse();
;int bbJoyType( int port=0 );
;int bbJoyDown( int n,int port=0 );
;int bbJoyHit( int n,int port=0 );
;int bbGetJoy( int port=0 );
;int bbWaitJoy( int port=0 );
;float bbJoyX( int port=0 );
;float bbJoyY( int port=0 );
;float bbJoyZ( int port=0 );
;float bbJoyU( int port=0 );
;float bbJoyV( int port=0 );
;float bbJoyPitch( int port=0 );
;float bbJoyYaw( int port=0 );
;float bbJoyRoll( int port=0 );
;int bbJoyHat( int port=0 );
;int bbJoyXDir( int port=0 );
;int bbJoyYDir( int port=0 );
;int bbJoyZDir( int port=0 );
;int bbJoyUDir( int port=0 );
;int bbJoyVDir( int port=0 );
;void bbFlushJoy();
;BBSound bbLoadSound( const char *src,int flags=0 );
;void bbFreeSound( BBSound sound );
;BBChannel bbPlaySound( BBSound sound );
;void bbLoopSound( BBSound sound );
;void bbSoundPitch( BBSound sound,int pitch );
;void bbSoundVolume( BBSound sound,float volume );
;void bbSoundPan( BBSound sound,float pan );
;BBChannel bbPlayMusic( const char *src,int mode=1 );
;BBChannel bbPlayCDTrack( int track,int mode=1 );
;void bbStopChannel( BBChannel channel );
;void bbPauseChannel( BBChannel channel );
;void bbResumeChannel( BBChannel channel );
;void bbChannelPitch( BBChannel channel,int pitch );
;void bbChannelVolume( BBChannel channel,float volume );
;void bbChannelPan( BBChannel channel,float pan );
;int bbChannelPlaying( BBChannel channel );
;void bbGraphics3D( int width,int height,int depth=0,int mode=0 );
;int bbCountGfxDrivers();
;const char *bbGfxDriverName( int n );
;int bbGfxDriver3D( int n );
;int bbGfxDriverCaps3D();
;int bbCountGfxModes3D();
;int bbGfxMode3DExists( int w,int h,int d );
;int bbGfxMode3D( int n );
;int bbWindowed3D();
;int bbGfxDriverX( int n );
;int bbGfxDriverY( int n );
;int bbGfxDriverHz( int n );
;void bbSetGfxDriver( int n );
;int bbGfxModeExists( int w,int h,int d );
;int bbCountGfxModes();
;int bbGfxModeWidth( int n );
;int bbGfxModeHeight( int n );
;int bbGfxModeDepth( int n );
;int bbGraphicsWidth();
;int bbGraphicsHeight();
;int bbGraphicsDepth();
;int bbAvailVidMem();
;int bbTotalVidMem();
;void bbGraphics( int w,int h,int d,int mode );
;BBCanvas bbFrontBuffer();
;BBCanvas bbBackBuffer();
;void bbEndGraphics();
;int bbGraphicsLost();
;int bbScanLine();
;void bbVWait( int n );
;void bbFlip( int vwait=1 );
;void bbSetBuffer( BBCanvas buff );
;BBCanvas bbGraphicsBuffer();
;int bbLoadBuffer( BBCanvas surf,const char *str );
;int bbSaveBuffer( BBCanvas surf,const char *str );
;void bbBufferDirty( BBCanvas buffer );
;void bbAutoBufferDirty( int enable );
;void bbLockBuffer( BBCanvas buff );
;void bbUnlockBuffer( BBCanvas buff );
;int bbReadPixel( int x,int y,BBCanvas buff );
;void bbWritePixel( int x,int y,int argb,BBCanvas buff );
;int bbReadPixelFast( int x,int y,BBCanvas buff );
;void bbWritePixelFast( int x,int y,int argb,BBCanvas buff );
;void bbCopyPixel( int src_x,int src_y,BBCanvas src,int dest_x,int dest_y,BBCanvas buff );
;void bbCopyPixelFast( int src_x,int src_y,BBCanvas src,int dest_x,int dest_y,BBCanvas buff );
;void bbOrigin( int x,int y );
;void bbViewport( int x,int y,int w,int h );
;void bbColor( int r,int g,int b );
;void bbClsColor( int r,int g,int b );
;void bbCls();
;void bbPlot( int x,int y );
;void bbLine( int x1,int y1,int x2,int y2 );
;void bbRect( int x,int y,int w,int h,int solid=1 );
;void bbOval( int x,int y,int w,int h,int solid=1 );
;void bbText( int x,int y,const char *t,int centre_x=0,int centre_y=0 );
;void bbCopyRect( int sx,int sy,int w,int h,int dx,int dy,BBCanvas src,BBCanvas dest );
;void bbGetColor( int x,int y );
;int bbColorRed();
;int bbColorGreen();
;int bbColorBlue();
;BBFont bbLoadFont( const char *name,int height,int bold,int italic,int underline );
;void bbFreeFont( BBFont f );
;void bbSetFont( BBFont f );
;int bbFontWidth();
;int bbFontHeight();
;int bbStringWidth( const char *str );
;int bbStringHeight( const char *str );
;BBImage bbLoadImage( const char *s );
;BBImage bbCopyImage( BBImage sourceimage );
;BBImage bbCreateImage( int w,int h,int n );
;BBImage bbLoadAnimImage( const char *s,int w,int h,int first,int cnt );
;void bbFreeImage( BBImage i );
;int bbSaveImage( BBImage i,const char *filename,int frame );
;void bbGrabImage( BBImage i,int x,int y,int n );
;BBCanvas bbImageBuffer( BBImage i,int n );
;void bbDrawImage( BBImage i,int x,int y,int frame );
;void bbDrawBlock( BBImage i,int x,int y,int frame );
;void bbTileImage( BBImage i,int x,int y,int frame );
;void bbTileBlock( BBImage i,int x,int y,int frame );
;void bbDrawImageRect( BBImage i,int x,int y,int r_x,int r_y,int r_w,int r_h,int frame );
;void bbDrawBlockRect( BBImage i,int x,int y,int r_x,int r_y,int r_w,int r_h,int frame );
;void bbMaskImage( BBImage i,int r,int g,int b );
;void bbHandleImage( BBImage i,int x,int y );
;void bbScaleImage( BBImage i,float w,float h );
;void bbResizeImage( BBImage i,float w,float h );
;void bbRotateImage( BBImage i,float angle );
;void bbTFormImage( BBImage i,float a,float b,float c,float d );
;void bbTFormFilter( int enable );
;void bbAutoMidHandle( int enable );
;void bbMidHandle( BBImage i );
;int bbImageWidth( BBImage i );
;int bbImageHeight( BBImage i );
;int bbImageXHandle( BBImage i );
;int bbImageYHandle( BBImage i );
;int bbImagesOverlap( BBImage i1,int x1,int y1,BBImage i2,int x2,int y2 );
;int bbImagesCollide( BBImage i1,int x1,int y1,int f1,BBImage i2,int x2,int y2,int f2 );
;int bbRectsOverlap( int x1,int y1,int w1,int h1,int x2,int y2,int w2,int h2 );
;int bbImageRectOverlap( BBImage i,int x,int y,int r_x,int r_y,int r_w,int r_h );
;int bbImageRectCollide( BBImage i,int x,int y,int f,int r_x,int r_y,int r_w,int r_h );
;void bbWrite( const char *str );
;void bbPrint( const char *str );
;const char *bbInput( const char *prompt );
;void bbLocate( int x,int y );
;BBMovie bbOpenMovie( const char *s );
;int bbDrawMovie( BBMovie movie,int x,int y,int w,int h );
;int bbMovieWidth( BBMovie movie );
;int bbMovieHeight( BBMovie movie );
;int bbMoviePlaying( BBMovie movie );
;void bbCloseMovie( BBMovie movie );
;void bbSetGamma( int r,int g,int b,float dr,float dg,float db );
;void bbUpdateGamma( int calibrate );
;float bbGammaRed( int n );
;float bbGammaGreen( int n );
;float bbGammaBlue( int n );
;void bbLoaderMatrix( const char *ext,float xx,float xy,float xz,float yx,float yy,float yz,float zx,float zy,float zz );
;int bbHWTexUnits();
;void bbHWMultiTex( int enable );
;void bbWBuffer( int enable );
;void bbDither( int enable );
;void bbAntiAlias( int enable );
;void bbWireFrame( int enable );
;void bbAmbientLight( float r,float g,float b );
;void bbClearCollisions();
;void bbCollisions( int src_type,int dest_type,int method,int response );
;void bbUpdateWorld( float elapsed=1.0 );
;void bbRenderWorld( float tween=1.0 );
;void bbCaptureWorld();
;int bbTrisRendered();
;float bbStats3D( int n );
;BBTexture bbLoadTexture( const char *file,int flags=1 );
;BBTexture bbCreateTexture( int w,int h,int flags=0,int frames=1 );
;BBTexture bbLoadTexture( const char *file,int flags );
;BBTexture bbCreateTexture( int w,int h,int flags,int frames );
;BBTexture bbLoadAnimTexture( const char *file,int flags,int w,int h,int first,int cnt );
;void bbFreeTexture( BBTexture t );
;void bbTextureBlend( BBTexture t,int blend );
;void bbTextureCoords( BBTexture t,int flags );
;void bbScaleTexture( BBTexture t,float u_scale,float v_scale );
;void bbRotateTexture( BBTexture t,float angle );
;void bbPositionTexture( BBTexture t,float u_pos,float v_pos );
;int bbTextureWidth( BBTexture t );
;int bbTextureHeight( BBTexture t );
;const char *bbTextureName( BBTexture t );
;void bbSetCubeFace( BBTexture t,int face );
;void bbSetCubeMode( BBTexture t,int mode );
;BBCanvas bbTextureBuffer( BBTexture t,int frame=0 );
;void bbClearTextureFilters();
;void bbTextureFilter( const char *t,int flags );
;BBBrush bbCreateBrush( float r=255.0f,float g=255.0f,float b=255.0f );
;BBBrush bbLoadBrush( const char *file,int texture_flags=1,float u_scale=1.0,float v_scale=1.0 );
;void bbFreeBrush( BBBrush b );
;void bbBrushColor( BBBrush br,float r,float g,float b );
;void bbBrushAlpha( BBBrush b,float alpha );
;void bbBrushShininess( BBBrush b,float n );
;void bbBrushTexture( BBBrush b,BBTexture t,int frame,int index );
;BBTexture bbGetBrushTexture( BBBrush b,int index );
;void bbBrushBlend( BBBrush b,int blend );
;void bbBrushFX( BBBrush b,int fx );
;BBModel bbCreateMesh( BBEntity p=0 );
;BBModel bbLoadMesh( const char *f,BBEntity p=0 );
;BBModel bbLoadAnimMesh( const char *f,BBEntity p=0 );
;BBModel bbCreateCube( BBEntity p=0 );
;BBModel bbCreateSphere( int segs=8,BBEntity p=0 );
;BBModel bbCreateCylinder( int segs=8,int solid=1,BBEntity p=0 );
;BBModel bbCreateCone( int segs=8,int solid=1,BBEntity p=0 );
;BBModel bbCopyMesh( BBModel m,BBEntity p=0 );
;void bbScaleMesh( BBModel m,float x,float y,float z );
;void bbRotateMesh( BBModel m,float x,float y,float z );
;void bbPositionMesh( BBModel m,float x,float y,float z );
;void bbFitMesh( BBModel m,float x,float y,float z,float w,float h,float d,int uniform=0 );
;void bbFlipMesh( BBModel m );
;void bbPaintMesh( BBModel m,BBBrush b );
;void bbAddMesh( BBModel src,BBModel dest );
;void bbUpdateNormals( BBModel m );
;void bbLightMesh( BBModel m,float r,float g,float b,float range,float x,float y,float z );
;float bbMeshWidth( BBModel m );
;float bbMeshHeight( BBModel m );
;float bbMeshDepth( BBModel m );
;int bbMeshesIntersect( BBModel a,BBModel b );
;int bbCountSurfaces( BBModel m );
;BBSurface bbGetSurface( BBModel m,int index );
;void bbMeshCullBox( BBModel m,float x,float y,float z,float w,float h,float d );
;BBSurface bbCreateSurface( BBModel m,BBBrush b=0 );
;BBSurface bbFindSurface( BBModel m,BBBrush b );
;BBBrush bbGetSurfaceBrush( BBSurface s );
;BBBrush bbGetEntityBrush( BBModel m );
;void bbClearSurface( BBSurface s,int verts,int tris );
;void bbPaintSurface( BBSurface s,BBBrush b );
;int bbAddVertex( BBSurface s,float x,float y,float z,float tu=0.0f,float tv=0.0f,float tw=0.0f );
;int bbAddTriangle( BBSurface s,int v0,int v1,int v2 );
;void bbVertexCoords( BBSurface s,int n,float x,float y,float z );
;void bbVertexNormal( BBSurface s,int n,float x,float y,float z );
;void bbVertexColor( BBSurface s,int n,float r,float g,float b,float a );
;void bbVertexTexCoords( BBSurface s,int n,float u,float v,float w,int set );
;int bbCountVertices( BBSurface s );
;int bbCountTriangles( BBSurface s );
;float bbVertexX( BBSurface s,int n );
;float bbVertexY( BBSurface s,int n );
;float bbVertexZ( BBSurface s,int n );
;float bbVertexNX( BBSurface s,int n );
;float bbVertexNY( BBSurface s,int n );
;float bbVertexNZ( BBSurface s,int n );
;float bbVertexRed( BBSurface s,int n );
;float bbVertexGreen( BBSurface s,int n );
;float bbVertexBlue( BBSurface s,int n );
;float bbVertexAlpha( BBSurface s,int n );
;float bbVertexU( BBSurface s,int n,int t );
;float bbVertexV( BBSurface s,int n,int t );
;float bbVertexW( BBSurface s,int n,int t );
;int bbTriangleVertex( BBSurface s,int n,int v );
;BBCamera bbCreateCamera( BBEntity p=0 );
;void bbCameraZoom( BBCamera c,float zoom );
;void bbCameraRange( BBCamera c,float nr,float fr );
;void bbCameraClsColor( BBCamera c,float r,float g,float b );
;void bbCameraClsMode( BBCamera c,int cls_color,int cls_zbuffer );
;void bbCameraProjMode( BBCamera c,int mode );
;void bbCameraViewport( BBCamera c,int x,int y,int w,int h );
;void bbCameraFogRange( BBCamera c,float nr,float fr );
;void bbCameraFogColor( BBCamera c,float r,float g,float b );
;void bbCameraFogMode( BBCamera c,int mode );
;int bbCameraProject( BBCamera c,float x,float y,float z );
;float bbProjectedX();
;float bbProjectedY();
;float bbProjectedZ();
;BBEntity bbCameraPick( BBCamera c,float x,float y );
;BBEntity bbLinePick( float x,float y,float z,float dx,float dy,float dz,float radius );
;BBEntity bbEntityPick( BBObject src,float range );
;int bbEntityVisible( BBObject src,BBObject dest );
;int bbEntityInView( BBEntity e,BBCamera c );
;float bbPickedX();
;float bbPickedY();
;float bbPickedZ();
;float bbPickedNX();
;float bbPickedNY();
;float bbPickedNZ();
;float bbPickedTime();
;BBObject bbPickedEntity();
;BBSurface bbPickedSurface();
;int bbPickedTriangle();
;BBLight bbCreateLight( int type=0,BBEntity p=0 );
;void bbLightColor( BBLight light,float r,float g,float b );
;void bbLightRange( BBLight light,float range );
;void bbLightConeAngles( BBLight light,float inner,float outer );
;BBPivot bbCreatePivot( BBEntity p=0 );
;BBSprite bbCreateSprite( BBEntity p=0 );
;BBSprite bbLoadSprite( const char *file,int texture_flags=1,BBEntity p=0 );
;void bbRotateSprite( BBSprite s,float angle );
;void bbScaleSprite( BBSprite s,float x,float y );
;void bbHandleSprite( BBSprite s,float x,float y );
;void bbSpriteViewMode( BBSprite s,int mode );
;BBMirror bbCreateMirror( BBEntity p=0 );
;BBPlaneModel bbCreatePlane( int segs=1,BBEntity p=0 );
;BBMD2Model bbLoadMD2( const char *file,BBEntity p=0 );
;void bbAnimateMD2( BBMD2Model m,int mode=1,float speed=1.0,int first=0,int last=9999,float trans=0.0 );
;float bbMD2AnimTime( BBMD2Model m );
;int bbMD2AnimLength( BBMD2Model m );
;int bbMD2Animating( BBMD2Model m );
;BBQ3BSPModel bbLoadBSP( const char *file,float gam,BBEntity p=0 );
;void bbBSPAmbientLight( BBQ3BSPModel t,float r,float g,float b );
;void bbBSPLighting( BBQ3BSPModel t,int lmap );
;BBTerrain bbCreateTerrain( int n,BBEntity p=0 );
;BBTerrain bbLoadTerrain( const char *file,BBEntity p=0 );
;void bbTerrainDetail( BBTerrain t,int n,int m );
;void bbTerrainShading( BBTerrain t,int enable );
;float bbTerrainX( BBTerrain t,float x,float y,float z );
;float bbTerrainY( BBTerrain t,float x,float y,float z );
;float bbTerrainZ( BBTerrain t,float x,float y,float z );
;int bbTerrainSize( BBTerrain t );
;float bbTerrainHeight( BBTerrain t,int x,int z );
;void bbModifyTerrain( BBTerrain t,int x,int z,float h,int realtime );
;BBEntity bbCreateListener( BBEntity p=0,float roll=1.0,float dopp=1.0,float dist=1.0 );
;BBChannel bbEmitSound( BBSound sound,BBObject o );
;BBEntity bbCopyEntity( BBEntity e,BBEntity p=0 );
;void bbFreeEntity( BBEntity e );
;void bbHideEntity( BBEntity e );
;void bbShowEntity( BBEntity e );
;void bbEntityParent( BBEntity e,BBEntity p=0,int global=1 );
;int bbCountChildren( BBEntity e );
;BBEntity bbGetChild( BBEntity e,int index );
;BBEntity bbFindChild( BBEntity e,const char *t );
;int bbLoadAnimSeq( BBObject o,const char *f );
;void bbSetAnimTime( BBObject o,float time,int seq );
;void bbAnimate( BBObject o,int mode=1,float speed=1.0f,int seq=0,float trans=0.0f );
;void bbSetAnimKey( BBObject o,int frame,int pos_key=1,int rot_key=1,int scl_key=1 );
;int bbExtractAnimSeq( BBObject o,int first,int last,int seq );
;int bbAddAnimSeq( BBObject o,int length );
;int bbAnimSeq( BBObject o );
;float bbAnimTime( BBObject o );
;int bbAnimLength( BBObject o );
;int bbAnimating( BBObject o );
;void bbPaintEntity( BBEntity e,BBBrush b );
;void bbEntityColor( BBModel m,float r,float g,float b );
;void bbEntityAlpha( BBModel m,float alpha );
;void bbEntityShininess( BBModel m,float shininess );
;void bbEntityTexture( BBModel m,BBTexture t,int frame=0,int index=0 );
;void bbEntityBlend( BBModel m,int blend );
;void bbEntityFX( BBModel m,int fx );
;void bbEntityAutoFade( BBModel m,float nr,float fr );
;void bbEntityOrder( BBObject o,int n );
;float bbEntityX( BBEntity e,int global=0 );
;float bbEntityY( BBEntity e,int global=0 );
;float bbEntityZ( BBEntity e,int global=0 );
;float bbEntityPitch( BBEntity e,int global=0 );
;float bbEntityYaw( BBEntity e,int global=0 );
;float bbEntityRoll( BBEntity e,int global=0 );
;float bbGetMatElement( BBEntity e,int row,int col );
;void bbTFormPoint( float x,float y,float z,BBEntity src,BBEntity dest );
;void bbTFormVector( float x,float y,float z,BBEntity src,BBEntity dest );
;void bbTFormNormal( float x,float y,float z,BBEntity src,BBEntity dest );
;float bbTFormedX();
;float bbTFormedY();
;float bbTFormedZ();
;float bbVectorYaw( float x,float y,float z );
;float bbVectorPitch( float x,float y,float z );
;float bbDeltaYaw( BBEntity src,BBEntity dest );
;float bbDeltaPitch( BBEntity src,BBEntity dest );
;void bbEntityType( BBObject o,int type,int recurs=0 );
;void bbEntityPickMode( BBObject o,int mode,int obs );
;BBEntity bbGetParent( BBEntity e );
;int bbGetEntityType( BBObject o );
;void bbEntityRadius( BBObject o,float x_radius,float y_radius=0.0 );
;void bbEntityBox( BBObject o,float x,float y,float z,float w,float h,float d );
;BBObject bbEntityCollided( BBObject o,int type );
;int bbCountCollisions( BBObject o );
;float bbCollisionX( BBObject o,int index );
;float bbCollisionY( BBObject o,int index );
;float bbCollisionZ( BBObject o,int index );
;float bbCollisionNX( BBObject o,int index );
;float bbCollisionNY( BBObject o,int index );
;float bbCollisionNZ( BBObject o,int index );
;float bbCollisionTime( BBObject o,int index );
;BBObject bbCollisionEntity( BBObject o,int index );
;BBSurface bbCollisionSurface( BBObject o,int index );
;int bbCollisionTriangle( BBObject o,int index );
;float bbEntityDistance( BBEntity src,BBEntity dest );
;void bbMoveEntity( BBEntity e,float x,float y,float z );
;void bbTurnEntity( BBEntity e,float p,float y,float r,int global=0 );
;void bbTranslateEntity( BBEntity e,float x,float y,float z,int global=0 );
;void bbPositionEntity( BBEntity e,float x,float y,float z,int global=0 );
;void bbScaleEntity( BBEntity e,float x,float y,float z,int global=0 );
;void bbRotateEntity( BBEntity e,float p,float y,float r,int global=0 );
;void bbPointEntity( BBEntity e,BBEntity t,float roll=0 );
;void bbAlignToVector( BBEntity e,float nx,float ny,float nz,int axis,float rate );
;void bbNameEntity( BBEntity e,const char *t );
;const char *bbEntityName( BBEntity e );
;const char *bbEntityClass( BBEntity e );
;void bbClearWorld( int e,int b,int t );
;void bbSetEntityID( BBEntity *e,int id );
;int bbEntityID( BBEntity *e );
;int bbActiveTextures();
'''

out = ""
lines = text.split('\n')
for line_index in range(len(lines)):
    line = lines[line_index]
    space_idx = line.find(' ')
    paren_idx = line.find('(')
    if space_idx != -1 and paren_idx != -1:
        str = line[space_idx+1:paren_idx]
        str = str.replace('char *','')
        str = f"{str}, '{str}'"
        if line_index != len(lines)-2:
            str += ",\\"
        str += ' '*(58-len(str))
        str += f"{line}\r\n";
        out += str
    if len(out)>2000 or line_index == len(lines)-1:
        out = out[:-2]  
        print(out)
        out = ""





